/**
 * YAML parse errors.
 */
export declare class ParseError extends SyntaxError {
    index: number;
    lineNumber: number;
    column: number;
    /**
     * Initialize this ParseError instance.
     * @param message The error message.
     * @param offset The offset number of this error.
     * @param line The line number of this error.
     * @param column The column number of this error.
     */
    constructor(message: string, offset: number, line: number, column: number);
}
